package org.zeroturnaround.javarebel.integration.jboss5;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

public class BaseClassLoaderDomainCBP extends JavassistClassBytecodeProcessor {
	public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
	  cp.importPackage("org.jboss.classloader.spi");
		cp.importPackage("org.jboss.classloader.spi.base");
		cp.importPackage("org.jboss.classloader.plugins");
		cp.importPackage("java.util");
		cp.importPackage("java.net");

		CtMethod findLoaderInExportsMethod = ctClass.getDeclaredMethod("findLoaderInExports", cp.get(new String[]{"org.jboss.classloader.spi.base.BaseClassLoader", String.class.getName(), boolean.class.getName()}));
		findLoaderInExportsMethod.setBody(
				"{     Loader loader = globalClassCache.get($2);\n" + 
				"      if (loader != null)\n" + 
				"      {\n" + 
				"         return loader;\n" + 
				"      }\n" + 
				"\n" + 
				"      if (globalClassBlackList.containsKey($2))\n" + 
				"      {\n" + 
				"         return null;\n" + 
				"      }\n" + 
				"      boolean canCache = true;\n" + 
				"      boolean canBlackList = true;\n" + 				
				"         for (Iterator i = classLoaders.iterator(); i.hasNext();) {\n" +
				"            ClassLoaderInformation info = (ClassLoaderInformation) i.next();\n" + 
				"            BaseDelegateLoader exported = info.getExported();\n" + 
				"            \n" + 
				"            // See whether the policies allow caching/blacklisting\n" + 
				"            BaseClassLoaderPolicy loaderPolicy = exported.getPolicy();\n" + 
				"            if (loaderPolicy == null || loaderPolicy.isCacheable() == false)\n" + 
				"               canCache = false;\n" + 
				"            if (loaderPolicy == null || loaderPolicy.isBlackListable() == false)\n" + 
				"               canBlackList = false;\n" + 
				"\n" + 
				"            if (exported.getResource($2) != null)\n" + 
				"            {\n" + 
				"               if (canCache)\n" + 
				"                  globalClassCache.put($2, exported);\n" + 
				"               return exported;\n" + 
				"            }\n" + 
				"         }\n" + 
				"      // Here is not found in the exports so can we blacklist it?\n" + 
				"      if (canBlackList)\n" + 
				"         globalClassBlackList.put($2, $2);\n" + 
				"      \n" + 
				"      return null;" +
				"}");	
		
		CtMethod getResourceFromExportsMethod = ctClass.getDeclaredMethod(
		    "getResourceFromExports", 
		    cp.get(new String[]{"org.jboss.classloader.spi.base.BaseClassLoader", String.class.getName(), boolean.class.getName()}));
		getResourceFromExportsMethod.setBody(
        "{     URL result = globalResourceCache.get($2);\n" + 
        "      if (globalResourceBlackList.containsKey($2))\n" + 
        "      {\n" + 
        "         return null;\n" + 
        "      }\n" + 
        "      boolean canCache = true;\n" + 
        "      boolean canBlackList = true;\n" + 
        "      \n" + 
        "         for (Iterator i = classLoaders.iterator(); i.hasNext();) {\n" +
        "            ClassLoaderInformation info = (ClassLoaderInformation) i.next();\n" +         
        "            BaseDelegateLoader loader = info.getExported();\n" + 
        "            \n" + 
        "            // See whether the policies allow caching/blacklisting\n" + 
        "            BaseClassLoaderPolicy loaderPolicy = loader.getPolicy();\n" + 
        "            if (loaderPolicy == null || loaderPolicy.isCacheable() == false)\n" + 
        "               canCache = false;\n" + 
        "            if (loaderPolicy == null || loaderPolicy.isBlackListable() == false)\n" + 
        "               canBlackList = false;\n" + 
        "\n" + 
        "            result = loader.getResource($2);\n" + 
        "            if (result != null)\n" + 
        "            {\n" + 
        "               if (canCache)\n" + 
        "                  globalResourceCache.put($2, result);\n" + 
        "               return result;\n" + 
        "            }\n" + 
        "         }\n" + 
        "      // Here is not found in the exports so can we blacklist it?\n" + 
        "      if (canBlackList)\n" + 
        "         globalResourceBlackList.put($2, $2);\n" + 
        "      return null;" +
        "}"); 
	}
}
