package org.zeroturnaround.javarebel.integration.netbeans;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtConstructor;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.bundled.javassist.CtNewMethod;
import org.zeroturnaround.javarebel.ClassBytecodeProcessor;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

public class NetbeansJarClassLoaderCBP extends JavassistClassBytecodeProcessor {

	public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
        cp.importPackage("java.util");
        cp.importPackage("java.net");
        cp.importPackage("org.zeroturnaround.javarebel");
        cp.importPackage("org.zeroturnaround.javarebel.support");
        cp.importPackage("org.zeroturnaround.javarebel.integration.generic");
        cp.importPackage("org.zeroturnaround.javarebel.integration.util");

        ctClass.addInterface(cp.get(ClassBytecodeProcessor.class.getName()));

        CtConstructor[] constructors = ctClass.getConstructors();
        for (int i = 0; i < constructors.length; i++) {
                CtConstructor constructor = constructors[i];
                constructor.insertAfter(
                		"IntegrationFactory.getInstance().registerClassLoader($0, new FindResourceClassResourceSource($0));" +
                		"addCoveredPackages(Arrays.asList(new String[]{\"com.zeroturnaround.javarebel\"}));"
                );
        }

        ctClass.addMethod(CtNewMethod.make("public byte[] process(ClassLoader cl, String classname, byte[] bytecode) {"
                + " return org.netbeans.PatchByteCode.patch(bytecode, classname);}", ctClass));

		CtMethod m = ctClass.getMethod("doLoadClass", "(Ljava/lang/String;Ljava/lang/String;)Ljava/lang/Class;");
		m.insertBefore(
				"{" +
				"try {" +
				"	IntegrationFactory.getInstance().addIntegrationProcessor($0, $2, $0);" +
				"	Class c = IntegrationFactory.getInstance().findReloadableClass($0, $2);" +
				"	if (c != null) return c;" +
				"} catch (ClassNotFoundException e) {}" +
				"}"
		);
	}

}
